<?php

/**
 * 追格马甲生成器
 *
 * 批量生成马甲用户，适用于酱茄-追格WordPress系列小程序、主题。
 * 
 * https://www.zhuige.com
 */

class ZhuiGe_User_Dummy_Admin_Settings
{
	private $plugin_name;
	private $version;

	public function __construct($plugin_name, $version)
	{
		$this->plugin_name = $plugin_name;
		$this->version = $version;
	}

	public function setup_plugin_options_menu()
	{
		//Add the menu to the Plugins set of menu items
		add_plugins_page(
			'追格马甲生成器', 					// The title to be displayed in the browser window for this page.
			'追格马甲生成器',					// The text to be displayed for this menu item
			'manage_options',						// Which type of users can see this menu item
			'zhuige_user_dummy',					// The unique ID - that is, the slug - for this menu item
			array($this, 'render_settings_page_content')				// The name of the function to call when rendering this menu's page
		);
	}

	public function default_dummy_setting()
	{
		$defaults = array(
			'dummy_once_count'	=>  10,
			'username_prefix'	=>	'zhuige_',
			'default_password'	=>	'www.zhuige.com',
			'default_avatar'	=>	'',
			'avatar_meta_key'	=>  'jiangqie_avatar',
			'nickname_suffix'	=>	'1',
			'nickname_suffix_custom'	=>	'%d',

		);

		return $defaults;
	}

	public function render_settings_page_content($active_tab = '')
	{
?>
		<!-- Create a header in the default WordPress 'wrap' container -->
		<div class="wrap">
			<h2><?php _e('追格马甲生成器', 'zhuige-user-dummy'); ?></h2>
			<?php settings_errors(); ?>

			<?php if (isset($_GET['tab'])) {
				$active_tab = sanitize_text_field(wp_unslash($_GET['tab']));
			} else if ($active_tab == 'dummy_setting') {
				$active_tab = 'dummy_setting';
			} else if ($active_tab == 'nickname_setting') {
				$active_tab = 'nickname_setting';
			} else if ($active_tab == 'avatar_setting') {
				$active_tab = 'avatar_setting';
			} else {
				$active_tab = 'dummy_create';
			} // end if/else 
			?>

			<h2 class="nav-tab-wrapper">
				<a href="?page=zhuige_user_dummy&tab=dummy_create" class="nav-tab <?php echo $active_tab == 'dummy_create' ? 'nav-tab-active' : ''; ?>"><?php _e('马甲生成', 'zhuige-user-dummy'); ?></a>
				<a href="?page=zhuige_user_dummy&tab=dummy_setting" class="nav-tab <?php echo $active_tab == 'dummy_setting' ? 'nav-tab-active' : ''; ?>"><?php _e('马甲设置', 'zhuige-user-dummy'); ?></a>
				<a href="?page=zhuige_user_dummy&tab=nickname_setting" class="nav-tab <?php echo $active_tab == 'nickname_setting' ? 'nav-tab-active' : ''; ?>"><?php _e('昵称库', 'zhuige-user-dummy'); ?></a>
				<a href="?page=zhuige_user_dummy&tab=avatar_setting" class="nav-tab <?php echo $active_tab == 'avatar_setting' ? 'nav-tab-active' : ''; ?>"><?php _e('头像库', 'zhuige-user-dummy'); ?></a>
				<!-- <a class="nav-tab" target="_blank" href="https://www.zhuige.com/">使用说明</a> -->
				<a class="nav-tab" target="_blank" href="https://www.zhuige.com/product/zxfree.html" style="color: red;">开源资讯小程序</a>
				<a class="nav-tab" target="_blank" href="https://www.zhuige.com/product/gwfree.html" style="color: red;">开源企业官网小程序</a>
				<a class="nav-tab" target="_blank" href="https://www.zhuige.com/product/ztfree.html" style="color: red;">开源资讯主题</a>
			</h2>

			<?php
			if ($active_tab == 'nickname_setting') {
				echo '<p>直接编辑插件目录下的nickname.txt即可，也可以在这里修改。请不要在昵称中包含HTML标签，以免不能正常使用。</p>';
			?>
				<p>
					<input type="text" placeholder="请使用英文逗号分割昵称" class="regular-text new-nick" />
					<a href="javascript:void(0)" class="button button-primary btn-add-user-nick">添加</a>
				</p>
				<?php
				$nicks = zhuige_user_dummy_file_content(JQ_USER_DUMMY_NICKNAME_FILE);
				$nicks = explode(',', $nicks);
				echo '<div style="display:flex;flex-wrap: wrap;">';
				foreach ($nicks as $nick) {
					if (empty($nick)) {
						continue;
					}
					$nick = esc_html($nick);
					echo '<div style="margin:1px 2px;padding:0 2px;border: 1px solid gray;border-radius: 2px">'
						. $nick
						. '&nbsp;<a href="javascript:void(0)" class="btn-del-user-nick" data-nick="' . $nick . '">X</a></div>';
				}
				echo '</div>';
			} else if ($active_tab == 'avatar_setting') {
				echo '<p>把头像图片放到插件目录下的avatar目录即可。请不要放入非图片文件，以免不能正常使用。</p>';

				$avatars = zhuige_user_dummy_avatars(JQ_USER_DUMMY_AVATAR_DIR);
				echo '<div style="display:flex;flex-wrap: wrap;">';
				foreach ($avatars as $avatar) {
					echo '<a href="' . esc_html($avatar) . '" target="_blank"><img src="' . esc_html($avatar) . '" style="margin:2px;width:64px;height:64px;" /></a>';
				}
				echo '</div>';
			} else if ($active_tab == 'dummy_setting') {
				?>
				<form method="post" action="options.php">
					<?php
					settings_fields('zhuige_dummy_setting');
					do_settings_sections('zhuige_dummy_setting');
					submit_button();
					?>
				</form>
			<?php
			} else {
				$result = zhuige_user_dummy_pre_create();
				$list = $result['list'];
			?>
				<p>修改马甲设置、昵称库或头像库后，可以在此预览生成效果。</p>
				<a class="button btn-dummy-create-preview">刷新</a>&nbsp;&nbsp;&nbsp;&nbsp;
				<a class="button btn-dummy-create" data-nick_start="<?php echo esc_html($result['nick_start']); ?>" data-avatar_start="<?php echo esc_html($result['avatar_start']); ?>">生成</a>
				<hr />
			<?php
				echo '<div style="display:flex;flex-wrap: wrap;">';
				foreach ($list as $item) {
					$avatar = (empty($item['avatar']) ? get_avatar_url(get_current_user_id()) : $item['avatar']);
					echo '<div style="display: flex;flex-direction: column;align-items: center;border: 1px solid gray;margin-bottom:5px;">';
					echo '<a href="' . esc_html($avatar) . '" target="_blank"><img src="' . esc_html($avatar) . '" style="margin:2px;width:64px;height:64px;" /></a>';
					echo '<span>' . esc_html($item['nick']) . '</span>';
					echo '</div>';
				}
				echo '</div>';
			}
			?>

		</div><!-- /.wrap -->
<?php
	}

	public function dummy_setting_callback()
	{
		
	}

	public function initialize_dummy_setting()
	{
		if (false == get_option('zhuige_dummy_setting')) {
			$default_array = $this->default_dummy_setting();
			update_option('zhuige_dummy_setting', $default_array);
		}

		add_settings_section(
			'section_dummy_setting',
			__('', 'zhuige-user-dummy'),
			array($this, 'dummy_setting_callback'),
			'zhuige_dummy_setting'
		);

		add_settings_field(
			'dummy_once_count',
			__('批量个数', 'zhuige-user-dummy'),
			array($this, 'dummy_once_count_callback'),
			'zhuige_dummy_setting',
			'section_dummy_setting'
		);

		add_settings_field(
			'username_prefix',
			__('用户名前缀', 'zhuige-user-dummy'),
			array($this, 'username_prefix_callback'),
			'zhuige_dummy_setting',
			'section_dummy_setting'
		);

		add_settings_field(
			'default_password',
			__('默认密码', 'zhuige-user-dummy'),
			array($this, 'default_password_callback'),
			'zhuige_dummy_setting',
			'section_dummy_setting'
		);

		// add_settings_field(
		// 	'default_avatar',
		// 	__('默认头像', 'zhuige-user-dummy'),
		// 	array($this, 'default_avatar_callback'),
		// 	'zhuige_dummy_setting',
		// 	'section_dummy_setting'
		// );

		add_settings_field(
			'avatar_meta_key',
			__('头像META KEY', 'zhuige-user-dummy'),
			array($this, 'avatar_meta_key_callback'),
			'zhuige_dummy_setting',
			'section_dummy_setting'
		);

		add_settings_field(
			'nickname_suffix',
			__('昵称后缀', 'zhuige-user-dummy'),
			array($this, 'nickname_suffix_callback'),
			'zhuige_dummy_setting',
			'section_dummy_setting'
		);


		register_setting(
			'zhuige_dummy_setting',
			'zhuige_dummy_setting',
			array($this, 'validate_dummy_setting')
		);
	}

	public function dummy_once_count_callback()
	{
		$options = get_option('zhuige_dummy_setting');
		echo '<p>一次批量生成马甲个数。</p>';
		echo '<input type="number" id="dummy_once_count" class="regular-text" name="zhuige_dummy_setting[dummy_once_count]" value="' . esc_attr($options['dummy_once_count']) . '" />';
	}

	public function username_prefix_callback()
	{
		$options = get_option('zhuige_dummy_setting');
		echo '<p>马甲用户账号统一前缀，方便识别马甲和使用。</p>';
		echo '<input type="text" id="username_prefix" class="regular-text" name="zhuige_dummy_setting[username_prefix]" value="' . esc_attr($options['username_prefix']) . '" />';
	}

	public function default_password_callback()
	{
		$options = get_option('zhuige_dummy_setting');
		echo '<p>马甲用户账号的默认密码。</p>';
		echo '<p>此值留空，则自动生成随机密码（<strong>没人知道密码是什么</strong>）。</p>';
		echo '<input type="text" id="default_password" class="regular-text" name="zhuige_dummy_setting[default_password]" value="' . esc_attr($options['default_password']) . '" />';
	}

	public function default_avatar_callback()
	{
		$options = get_option('zhuige_dummy_setting');
		echo '<p>马甲用户账号的默认头像。</p>';
		echo '<input type="text" id="default_avatar" class="regular-text" name="zhuige_dummy_setting[default_avatar]" value="' . esc_attr($options['default_avatar']) . '" />';
	}

	public function avatar_meta_key_callback()
	{
		$options = get_option('zhuige_dummy_setting');
		echo '<p>马甲用户头像使用的meta key。酱茄系列产品都是：jiangqie_avatar。</p>';
		echo '<p style="color:red;">其他产品请咨询其他产品作者："头像是如何存储的?"。</p>';
		echo '<p>留空则使用WordPress默认头像机制。</p>';
		echo '<p style="color:red;">此值设置后，不要再修改；否则，之前生成的马甲头像无法正确读取。</p>';
		echo '<input type="text" id="avatar_meta_key" class="regular-text" name="zhuige_dummy_setting[avatar_meta_key]" value="' . esc_attr($options['avatar_meta_key']) . '" />';
	}

	public function nickname_suffix_callback()
	{
		$options = get_option('zhuige_dummy_setting');

		echo '<p>如果马甲用户昵称已存在，自动在后面加后缀。</p>';
		// echo '<p>选择"无后缀"，昵称库耗尽，则无法再生成新马甲。</p>';
		echo '<p>选择"无后缀"，有可能生成昵称重复的马甲。</p>';

		echo '<input type="radio" id="nickname_suffix_0" name="zhuige_dummy_setting[nickname_suffix]" value="0"' . checked(0, $options['nickname_suffix'], false) . '/>';
		echo '&nbsp;';
		echo '<label for="nickname_suffix_0">无后缀</label>';
		echo '&nbsp;&nbsp;&nbsp;';
		echo '<input type="radio" id="nickname_suffix_1" name="zhuige_dummy_setting[nickname_suffix]" value="1"' . checked(1, $options['nickname_suffix'], false) . '/>';
		echo '&nbsp;';
		echo '<label for="nickname_suffix_1">1,2,3,4...</label>';
		echo '&nbsp;&nbsp;&nbsp;';
		echo '<input type="radio" id="nickname_suffix_2" name="zhuige_dummy_setting[nickname_suffix]" value="2"' . checked(2, $options['nickname_suffix'], false) . '/>';
		echo '&nbsp;';
		echo '<label for="nickname_suffix_2">No.1,No.2...</label>';
		echo '&nbsp;&nbsp;&nbsp;';
		echo '<input type="radio" id="nickname_suffix_3" name="zhuige_dummy_setting[nickname_suffix]" value="3"' . checked(3, $options['nickname_suffix'], false) . '/>';
		echo '&nbsp;';
		echo '<label for="nickname_suffix_3">1号,2号...</label>';
		echo '&nbsp;&nbsp;&nbsp;';
		echo '<input type="radio" id="nickname_suffix_99" name="zhuige_dummy_setting[nickname_suffix]" value="99"' . checked(99, $options['nickname_suffix'], false) . '/>';
		echo '&nbsp;';
		echo '<label for="nickname_suffix_99">自定义</label>';

		echo '<input type="text" id="nickname_suffix_custom" name="zhuige_dummy_setting[nickname_suffix_custom]" value="' . esc_attr($options['nickname_suffix_custom']) . '" />';
	}

	public function validate_dummy_setting($input)
	{
		$output = array();
		foreach ($input as $key => $value) {
			if (isset($input[$key])) {
				$output[$key] = strip_tags(stripslashes($input[$key]));
			}
		}

		return apply_filters('validate_dummy_setting', $output, $input);
	}
}
