<?php

/**
 * 追格马甲生成器
 *
 * 批量生成马甲用户，适用于酱茄-追格WordPress系列小程序、主题。
 * 
 * https://www.zhuige.com
 */

defined('ABSPATH') or die("Direct access to the script does not allowed");

class ZhuiGe_User_Dummy_AJAX
{
    protected static $instance = null;

    public function __construct()
    {
        if (is_admin()) {
            add_action('wp_ajax_admin_create_user_dummy', array($this, 'ajax_create_user_dummy'));
            add_action('wp_ajax_admin_add_user_nick', array($this, 'ajax_add_user_nick'));
            add_action('wp_ajax_admin_del_user_nick', array($this, 'ajax_del_user_nick'));
        }
    }

    public static function get_instance()
    {
        if (null == self::$instance) {
            self::$instance = new self;
        }

        return self::$instance;
    }

    public function ajax_create_user_dummy()
    {
		$nick_start = (isset($_POST['nick_start'])) ? sanitize_text_field(wp_unslash($_POST['nick_start'])) : '0';
		$avatar_start = (isset($_POST['avatar_start'])) ? sanitize_text_field(wp_unslash($_POST['avatar_start'])) : '0';

        $nick_start = (int)$nick_start;
        $avatar_start = (int)$avatar_start;

        $result = zhuige_user_dummy_pre_create($avatar_start, $nick_start);
        $list = $result['list'];
        $options = get_option('zhuige_dummy_setting');
        foreach ($list as $item) {
            $user_id = wp_insert_user([
				'user_login' => $options['username_prefix'] . uniqid(),
				'nickname' => $item['nick'],
				'first_name' => $item['nick'],
				'display_name' => $item['nick'],
				'role' => 'subscriber',
				'user_pass' => empty($options['default_password']) ? wp_generate_password(16, false) : $options['default_password'],
			]);

            if (!empty($item['avatar'])) {
                update_user_meta($user_id,  $options['avatar_meta_key'], $item['avatar']);
            }
        }

        wp_send_json_success('OK');

        die();
    }

    public function ajax_add_user_nick()
    {
		$nicks = (isset($_POST['nicks'])) ? sanitize_text_field(wp_unslash($_POST['nicks'])) : '';
        $nicks = explode(',', $nicks);
        foreach ($nicks as $nick) {
            if (empty($nick)) {
                continue;
            }

            file_put_contents(JQ_USER_DUMMY_NICKNAME_FILE, $nick . ',', FILE_APPEND);
        }

        wp_send_json_success('OK');
        die();
    }

    public function ajax_del_user_nick()
    {	
		$del_nick = (isset($_POST['nick'])) ? sanitize_text_field(wp_unslash($_POST['nick'])) : '';

        $nicks = zhuige_user_dummy_file_content(JQ_USER_DUMMY_NICKNAME_FILE);

        file_put_contents(JQ_USER_DUMMY_NICKNAME_FILE, '');

		$nicks = explode(',', $nicks);
        foreach ($nicks as $nick) {
            if (empty($nick) || $nick == $del_nick) {
                continue;
            }

            file_put_contents(JQ_USER_DUMMY_NICKNAME_FILE, $nick . ',', FILE_APPEND);
        }

        wp_send_json_success('OK');
        die();
    }

}

$zhuige_user_dummy_ajax = new ZhuiGe_User_Dummy_AJAX();
