<?php

/**
 * 追格马甲生成器
 *
 * 批量生成马甲用户，适用于酱茄-追格WordPress系列小程序、主题。
 * 
 * https://www.zhuige.com
 */

class ZhuiGe_User_Dummy
{
	protected $loader;
	protected $plugin_name;
	protected $version;

	public function __construct()
	{
		$this->plugin_name = 'zhuige-user-dummy';
		$this->version = JQ_USER_DUMMY_VERSION;

		$this->load_dependencies();
		$this->set_locale();
		$this->define_admin_hooks();
		$this->define_public_hooks();
	}

	private function load_dependencies()
	{
		require_once JQ_USER_DUMMY_BASE_DIR . 'includes/class-zhuige-user-dummy-loader.php';
		require_once JQ_USER_DUMMY_BASE_DIR . 'includes/class-zhuige-user-dummy-i18n.php';
		require_once JQ_USER_DUMMY_BASE_DIR . 'admin/class-zhuige-user-dummy-admin.php';
		require_once JQ_USER_DUMMY_BASE_DIR . 'public/class-zhuige-user-dummy-public.php';
		require_once JQ_USER_DUMMY_BASE_DIR . 'includes/class-zhuige-user-dummy-ajax.php';

		$this->loader = new ZhuiGe_User_Dummy_Loader();
	}

	private function set_locale()
	{
		$plugin_i18n = new ZhuiGe_User_Dummy_i18n();
		$this->loader->add_action('plugins_loaded', $plugin_i18n, 'load_plugin_textdomain');
	}

	private function define_admin_hooks()
	{
		if (!is_admin()) {
			return;
		}
		
		$plugin_admin = new ZhuiGe_User_Dummy_Admin($this->get_plugin_name(), $this->get_version());
		$plugin_settings = new ZhuiGe_User_Dummy_Admin_Settings($this->get_plugin_name(), $this->get_version());

		$this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_styles');
		$this->loader->add_action('admin_enqueue_scripts', $plugin_admin, 'enqueue_scripts');

		$this->loader->add_action('admin_menu', $plugin_settings, 'setup_plugin_options_menu');
		$this->loader->add_action('admin_init', $plugin_settings, 'initialize_dummy_setting');
	}

	private function define_public_hooks()
	{
		$plugin_public = new ZhuiGe_User_Dummy_Public($this->get_plugin_name(), $this->get_version());

		$this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_styles');
		$this->loader->add_action('wp_enqueue_scripts', $plugin_public, 'enqueue_scripts');
	}

	public function run()
	{
		$this->loader->run();
	}

	public function get_plugin_name()
	{
		return $this->plugin_name;
	}

	public function get_loader()
	{
		return $this->loader;
	}

	public function get_version()
	{
		return $this->version;
	}
}
